
#include "includes.h"

volatile unsigned int ticks = 0;
unsigned int Tim0Per;
unsigned char usb_flag;

void Delay (Int32U Dly)
{
volatile Int32U Dly1 = Dly;
  for(;Dly1;--Dly1);
}

void Dly100us (void *arg)
{
volatile Int32U Dly = (Int32U)arg;
  for(;Dly;--Dly)
  {
    Delay(300);
  }
}

// UART0 Send char
void Uart0SendChar (Int8U c)
{
  UART_SendData(UART0, c);
  while(UART_GetFlagStatus(UART0, UART_FLAG_TxFIFOFull) != RESET);
}

// UART1 Send char
void Uart1SendChar (Int8U c)
{
  UART_SendData(UART1, c);
  while(UART_GetFlagStatus(UART1, UART_FLAG_TxFIFOFull) != RESET);
}

// UART2 Send char
void Uart2SendChar (Int8U c)
{
  UART_SendData(UART2, c);
  while(UART_GetFlagStatus(UART2, UART_FLAG_TxFIFOFull) != RESET);
}

// UART0 receive char
Int8U Uart0ReceiveChar (void)
{
Int8U Data;
  while(UART_GetFlagStatus(UART0, UART_FLAG_RxFIFOEmpty) == SET);
  Data = UART0->DR;
  return(Data);
}

// UART1 receive char
Int8U Uart1ReceiveChar (void)
{
Int8U Data;
  while(UART_GetFlagStatus(UART1, UART_FLAG_RxFIFOEmpty) == SET);
  Data = UART1->DR;
  return(Data);
}

// UART2 receive char
Int8U Uart2ReceiveChar (void)
{
Int8U Data;
  while(UART_GetFlagStatus(UART2, UART_FLAG_RxFIFOEmpty) == SET);
  Data = UART2->DR;
  return(Data);
}

// UART0 receive char test
Int8U Uart0ReceiveCharTest (void)
{
  return(UART_GetFlagStatus(UART0, UART_FLAG_RxFIFOEmpty) != SET);
}

// UART1 receive char
Int8U Uart1ReceiveCharTest (void)
{
  return(UART_GetFlagStatus(UART1, UART_FLAG_RxFIFOEmpty) != SET);
}

// UART2 receive char
Int8U Uart2ReceiveCharTest (void)
{
  return(UART_GetFlagStatus(UART2, UART_FLAG_RxFIFOEmpty) != SET);
}

// Get ch
int getchar(void)
{
  return(Uart0ReceiveChar());
}

// Send char
int putchar (int c)
{
  Uart0SendChar(c);
  return(c);
}
// kbdhit
Boolean kbdhit(void)
{
  return(Uart0ReceiveCharTest());
}


// main function
int main()
{

  // Init structure
  UART_InitTypeDef UART_InitStructure;
  GPIO_InitTypeDef GPIO_InitStructure;

  // System initialization
  SCU_MCLKSourceConfig(SCU_MCLK_OSC);
  SCU_FMICLKDivisorConfig(SCU_FMICLK_Div2);
  FMI_Config(FMI_READ_WAIT_STATE_2,FMI_WRITE_WAIT_STATE_0, FMI_PWD_ENABLE,\
             FMI_LVD_ENABLE,FMI_FREQ_HIGH);

  SCU_HCLKDivisorConfig(SCU_HCLK_Div1);
  SCU_PCLKDivisorConfig(SCU_PCLK_Div2);
  SCU_PLLFactorsConfig(N,M,P);              /* PLL = 96 MHz */
  SCU_PLLCmd(ENABLE);                       /* PLL Enabled  */
  SCU_MCLKSourceConfig(SCU_MCLK_PLL);       /* MCLK = PLL   */

  SCU->EMPTY2[0] = 0;
  SCU->EMPTY2[1] = 0;


  // GPIO initialization
  SCU_APBPeriphClockConfig(__GPIO0, ENABLE);
  GPIO_DeInit(GPIO0);
  SCU_APBPeriphClockConfig(__GPIO1, ENABLE);
  GPIO_DeInit(GPIO1);
  SCU_APBPeriphClockConfig(__GPIO2, ENABLE);
  GPIO_DeInit(GPIO2);
  SCU_APBPeriphClockConfig(__GPIO3, ENABLE);
  GPIO_DeInit(GPIO3);
  SCU_APBPeriphClockConfig(__GPIO4, ENABLE);
  GPIO_DeInit(GPIO4);
  SCU_APBPeriphClockConfig(__GPIO5, ENABLE);
  GPIO_DeInit(GPIO5);
  SCU_APBPeriphClockConfig(__GPIO6, ENABLE);
  GPIO_DeInit(GPIO6);
  SCU_APBPeriphClockConfig(__GPIO7, ENABLE);
  GPIO_DeInit(GPIO7);
  SCU_APBPeriphClockConfig(__GPIO8, ENABLE);
  GPIO_DeInit(GPIO8);
  SCU_APBPeriphClockConfig(__GPIO9, ENABLE);
  GPIO_DeInit(GPIO9);


  // UART initialization
  SCU_APBPeriphClockConfig(__UART0, ENABLE);
  UART_DeInit(UART0);
  SCU_APBPeriphClockConfig(__UART1, ENABLE);
  UART_DeInit(UART1);
  SCU_APBPeriphClockConfig(__UART2, ENABLE);
  UART_DeInit(UART2);

  UART_Cmd(UART0, DISABLE);
  UART_Cmd(UART1, DISABLE);
  UART_Cmd(UART2, DISABLE);

  /* Gonfigure P4.0*/
  GPIO_ANAPinConfig(GPIO_ANAChannelALL,ENABLE);

  /*Gonfigure UART1_Tx pin GPIO3.3*/
  GPIO_InitStructure.GPIO_Direction = GPIO_PinOutput;
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;
  GPIO_InitStructure.GPIO_Type = GPIO_Type_PushPull ;
  GPIO_InitStructure.GPIO_IPConnected = GPIO_IPConnected_Disable;
  GPIO_InitStructure.GPIO_Alternate = GPIO_OutputAlt1  ;
  GPIO_Init (GPIO3, &GPIO_InitStructure);
  GPIO_WriteBit(GPIO3,GPIO_Pin_3,Bit_RESET);

  /*Gonfigure UART0_Rx pin GPIO5.1*/
  GPIO_InitStructure.GPIO_Direction = GPIO_PinInput;
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;
  GPIO_InitStructure.GPIO_Type = GPIO_Type_PushPull ;
  GPIO_InitStructure.GPIO_IPConnected = GPIO_IPConnected_Enable;
  GPIO_InitStructure.GPIO_Alternate = GPIO_InputAlt1  ;
  GPIO_Init (GPIO5, &GPIO_InitStructure);

  /*Gonfigure UART0_Tx pin GPIO5.0*/
  GPIO_InitStructure.GPIO_Direction = GPIO_PinOutput;
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;
  GPIO_InitStructure.GPIO_Type = GPIO_Type_PushPull ;
  GPIO_InitStructure.GPIO_Alternate = GPIO_OutputAlt3  ;
  GPIO_Init (GPIO5, &GPIO_InitStructure);

  UART_StructInit(&UART_InitStructure);
  UART_InitStructure.UART_WordLength = UART_WordLength_8D;
  UART_InitStructure.UART_StopBits = UART_StopBits_1;
  UART_InitStructure.UART_Parity = UART_Parity_No ;
  UART_InitStructure.UART_BaudRate = 115200;
  UART_InitStructure.UART_HardwareFlowControl = UART_HardwareFlowControl_None;
  UART_InitStructure.UART_Mode = UART_Mode_Tx_Rx;
  UART_InitStructure.UART_FIFO = UART_FIFO_Disable;

  UART_Init(UART0, &UART_InitStructure);

  /* Enable the UART0 */
  UART_Cmd(UART0, ENABLE);

  /* VIC Configuration */
  SCU_AHBPeriphClockConfig(__VIC, ENABLE);
  VIC_DeInit();

  VIC_Config(TIM0_ITLine,VIC_IRQ , VIC_Slot3);
  VIC_ITCmd(TIM0_ITLine, ENABLE);
  TIM0_CR1_bit.EN = 1;              // enable counting

  // Init Timer0
  SCU_PRR1_bit.RST_TIM01 = 0;       // Reset of TIM01
  SCU_PCGR1_bit.TIM01 = 1;          // Enable clock of TIM01
  SCU_PRR1_bit.RST_TIM01 = 1;       // Release reset of TIM01
  TIM0_CR2_bit.CC = TIM_PSC(TIM_0_RES)-1; // Set TIM01 perscaler
  TIM0_CR2_bit.OC1IE = 1;           // TIM0 output compare interrupt enable
  // Set timer period
  Tim0Per   = TIM0_PER(TICK_PER_SEC);
  TIM0_OC1R = TIM0_CNTR + Tim0Per;

  // Init USB Hw
  USB_HwInit(VIC_Slot0,VIC_Slot1);
  // Init USB Core
  UsbCoreInit(UsbClassAudioConfigure);
  // Init Audio
  AudioClassInit(VIC_Slot2);

  // Enable interrupts
  __enable_interrupt();

  usb_flag=1;

  printf("\n\rWelcome OLIMEX STR-E912 development board");
  printf("\n\r\t www.olimex.com/dev");
  printf("\n\r");
  printf("\n\r Program demonstrate audio and USB device");
  printf("\n\r Please put MIC and HEADPHONE and test audio device");
  printf("\n\r Please put USB cable to test this device");


  while(usb_flag)
  {
    // check for USB cable
    if((UsbCoreReq(UsbCoreReqDevState) == UsbDevStatusConfigured) && !UsbCoreReq(UsbCoreReqDevSusState)) {
      printf("\n\r\n\rUSB test pass!");
      usb_flag=0;
    }
  }

  // loop forever
  while(1);
}
